;################################################################################
;#										#
;# avr-chipbasic2 - single chip basic computer with ATmega644			#
;# dataflash file manager 							#
;# copyright (c) 2006/2007 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;delete file
;------------------------------------------------------------------------------
dfile_delete:	clr	tempreg4		;first file	
dfile_del_00:	rcall	dfile_check		;check for dataflash
		ldi	XL,0x04			;color scheme (green on black)
		libmio_color
		ldi	YL,1			;alert box
		ldi	YH,2
		ldi	ZL,28
		ldi	ZH,21
		libmio_whbox
		ldi	XL,0x40			;color scheme (green on black)
		libmio_color		
		libmio_thistext
		.db	3,2,"Delete file",0

		
dfile_del_01:	rcall	dfile_select		;select a file
		sts	bas_partab,tempreg4
		libdfl_gettype			;get type
		cpi	tempreg1,0xfc		;empty
		breq	dfile_del_01		;non existing file
		rcall	dfile_adel		;ask for deleting
		cpi	tempreg1,0x01		;yes
		brne	dfile_del_02
		mov	XL,tempreg4		;filenumber
		rcall	dfile_wal		;draw alert box
		libdfl_delete

dfile_del_02:	ret


;------------------------------------------------------------------------------
;save file
;------------------------------------------------------------------------------
dfile_savebas:	clr	tempreg4		;first file

dfile_save_00:	rcall	dfile_check		;check for dataflash
		ldi	XL,0x04			;color scheme (green on black)
		libmio_color
		ldi	YL,1			;window box
		ldi	YH,2
		ldi	ZL,28
		ldi	ZH,21
		libmio_whbox
		ldi	XL,0x40			;color scheme (green on black)
		libmio_color
		ldi	XL,0x10			;BASIC
		sts	bas_partab+4,XL		;set file type		
		libmio_thistext
		.db	3,2,"Save file",0

		
dfile_save_01:	rcall	dfile_select
		sts	bas_partab,tempreg4
		libdfl_gettype			;get type

		cpi	tempreg1,0xe0		;empty
		brcc	dfile_save_02
		cpi	tempreg1,0x10		;basic
		breq	dfile_save_04		
		rcall	dfile_e_cns		;cannot save on this
		rjmp	dfile_save_00		;loop
				
dfile_save_02:	libdfl_free			;count free pages
		cpi	YH,0x00			;<256
		brne	dfile_save_03
		cpi	YL,0x0c			;needed pages for a program
		brcc	dfile_save_03		;we have...
		rcall	dfile_e_nsl		;no space left
		rjmp	dfile_save_00		;loop
dfile_save_03:	rcall	dfile_wal		;box
		rcall	dfile_bsave		;save this file
		ret				;end
		
dfile_save_04:	rcall	dfile_over		;ask for overwrite
		cpi	tempreg1,0x01		;yes?
		brne	dfile_save_00
		rcall	dfile_wal
		rcall	dfile_bover
		ret

;------------------------------------------------------------------------------
;backup
;------------------------------------------------------------------------------
dfile_backup:	clr	tempreg4		;first file

dfile_mbup_00:	rcall	dfile_check		;check for dataflash
		ldi	XL,0x04			;color scheme (green on black)
		libmio_color
		ldi	YL,1			;alert box
		ldi	YH,2
		ldi	ZL,28
		ldi	ZH,21
		libmio_whbox
		ldi	XL,0x40			;color scheme (green on black)
		libmio_color		
		ldi	XL,0x12			;BASIC
		sts	bas_partab+4,XL		;set file type		
		libmio_thistext
		.db	3,2,"Backup",0,0

		
dfile_mbup_01:	rcall	dfile_select
		sts	bas_partab,tempreg4
		libdfl_gettype			;get type
		cpi	tempreg1,0x90		;empty
		brcc	dfile_mbup_02
		cpi	tempreg1,0x12		;backup
		breq	dfile_mbup_04		
		rcall	dfile_e_cns		;cannot save on this
		rjmp	dfile_mbup_00		;loop
				
dfile_mbup_02:	libdfl_free			;count free pages
		cpi	YH,0x00			;<256
		brne	dfile_mbup_03
		cpi	YL,0x60			;needed pages for a backup
		brcc	dfile_mbup_03		;we have...
		rcall	dfile_e_nsl		;no space left
		rjmp	dfile_mbup_00		;loop
dfile_mbup_03:	rcall	dfile_wal
		rcall	dfile_msave		;save this file
		ret				;end
		
dfile_mbup_04:	rcall	dfile_over		;ask for overwrite
		cpi	tempreg1,0x01		;yes?
		brne	dfile_mbup_00
		rcall	dfile_wal
		rcall	dfile_mover
		ret	
		
;------------------------------------------------------------------------------
;load file
;------------------------------------------------------------------------------
dfile_loadbas:	clr	tempreg4		;first file

dfile_load_00:	rcall	dfile_check		;check for dataflash
		ldi	XL,0x04			;color scheme (green on black)
		libmio_color
		ldi	YL,1			;alert box
		ldi	YH,2
		ldi	ZL,28
		ldi	ZH,21
		libmio_whbox
		ldi	XL,0x40			;color scheme (green on black)
		libmio_color		
		libmio_thistext
		.db	3,2,"Load file",0

		
dfile_load_01:	rcall	dfile_select
		sts	bas_partab,tempreg4
		libdfl_gettype			;get type
		cpi	tempreg1,0x10		;basic
		breq	dfile_load_02		
		rcall	dfile_e_cnlb		;cannot load
		rjmp	dfile_load_00		;loop
				
dfile_load_02:	rcall	dfile_bload
		ret						


;------------------------------------------------------------------------------
;restore
;------------------------------------------------------------------------------
dfile_restore:	clr	tempreg4		;first file

dfile_rest_00:	rcall	dfile_check		;check for dataflash
		ldi	XL,0x04			;color scheme (green on black)
		libmio_color
		ldi	YL,1			;alert box
		ldi	YH,2
		ldi	ZL,28
		ldi	ZH,22
		libmio_whbox
		ldi	XL,0x40			;color scheme (green on black)
		libmio_color
		libmio_thistext
		.db	3,2,"Restore",0

		
dfile_rest_01:	rcall	dfile_select
		sts	bas_partab,tempreg4
		libdfl_gettype			;get type
		cpi	tempreg1,0x12		;backup
		breq	dfile_rest_02		
		rcall	dfile_e_cnlm		;cannot load
		rjmp	dfile_rest_00		;loop
				
dfile_rest_02:	rcall	dfile_mload
		ret						


;------------------------------------------------------------------------------
;get type (file=tempreg4)
;------------------------------------------------------------------------------
dfile_gtype:	mov	XL,tempreg4		;file number
		swap	XL
		mov	XH,XL
		andi	XL,0xf0
		andi	XH,0x0f
		libdfl_gettype
		ret
		
		
;------------------------------------------------------------------------------
;select an entry
;------------------------------------------------------------------------------
dfile_select:
dfile_sel_01:	rcall	dfile_list		;list files
dfile_sel_02:	rcall	dfile_inv		;invert selected
dfile_sel_03:	libmio_waitkey			;wait for key
		cpi	tempreg1,0xed		;ESC
		brne	dfile_sel_10		;no
		rcall	dfile_wnk
		pop	tempreg1		;kill stack
		pop	tempreg1
		ret				;end now
		
dfile_sel_10:	cpi	tempreg1,0xea		;enter
		brne	dfile_sel_15		;no
		ret
						;end
dfile_sel_15:	cpi	tempreg1,0xe0		;pos 1
		brne	dfile_sel_20
		rcall	dfile_reinv		;re-invert
		clr	tempreg4		;first pos
		rjmp	dfile_sel_01		;loop

dfile_sel_20:	cpi	tempreg1,0xe1		;pos 1
		brne	dfile_sel_25
		rcall	dfile_reinv		;re-invert
		lds	tempreg4,bas_partab+8	;maximum
		rjmp	dfile_sel_01		;loop

dfile_sel_25:	cpi	tempreg1,0xe4		;up
		brne	dfile_sel_30
		cpi	tempreg4,0x00
		breq	dfile_sel_03		;do nothing
		rcall	dfile_reinv		;re-invert
		subi	tempreg4,0x01		;-1
		mov	tempreg1,tempreg4
		andi	tempreg1,0x0f
		cpi	tempreg1,0x0f
		breq	dfile_sel_01		;page change
		rjmp	dfile_sel_02		;no page change

dfile_sel_30:	cpi	tempreg1,0xe5		;down
		brne	dfile_sel_35		;no
		lds	tempreg1,bas_partab+8	;maximum
		cp	tempreg1,tempreg4	
		brne	dfile_sel_31
		rjmp	dfile_sel_03		;do nothing

dfile_sel_31:	rcall	dfile_reinv		;re-invert
		inc	tempreg4		;+1
		mov	tempreg1,tempreg4
		andi	tempreg1,0x0f
		breq	dfile_sel_01		;page change
		rjmp	dfile_sel_02		;no page change
		
dfile_sel_35:	cpi	tempreg1,0xe6		;pageup
		brne	dfile_sel_40		;no
		cpi	tempreg4,0x10
		brcs	dfile_sel_03		;do nothing
		rcall	dfile_reinv		;re-invert
		subi	tempreg4,0x10		;-16
		rjmp	dfile_sel_01		;page change

dfile_sel_40:	cpi	tempreg1,0xe7		;pagedown
		brne	dfile_sel_45		;no
		lds	tempreg1,bas_partab+8
		subi	tempreg1,0x10
		cp	tempreg1,tempreg4
		brcs	dfile_sel_45		;do nothing
		rcall	dfile_reinv		;re-invert
		subi	tempreg4,0xf0		;+16
		rjmp	dfile_sel_01		;page change
		
dfile_sel_45:	rjmp	dfile_sel_03		;loop		
		
		
;------------------------------------------------------------------------------
;check flash for useability
;------------------------------------------------------------------------------
dfile_check:	call	libdfl_stat		;get flash status
		cpi	tempreg1,0x9c		;0.5M
		breq	dfile_check_01
		cpi	tempreg1,0xa4		;1M
		breq	dfile_check_03
		pop	tempreg1		;kill stack
		pop	tempreg1		;kill stack
		rjmp	dfile_e_ndf		;show error: not found

dfile_check_01:	ldi	tempreg1,0x7f		;*16
		sts	bas_partab+8,tempreg1	;store no of pages
dfile_check_02:	libdfl_checkformat		;test for valid format
		cpi	tempreg1,0x01		;OK
		breq	dfile_check_04
		pop	tempreg1		;kill stack
		pop	tempreg1		;killstack
		rjmp	dfile_e_nfor		;show error: not formatted

dfile_check_03:	ldi	tempreg1,0xff		;*16
		sts	bas_partab+8,tempreg1	;store no of pages
		rjmp	dfile_check_02
		
dfile_check_04:	ret
		
;------------------------------------------------------------------------------
;error:not formatted  
;------------------------------------------------------------------------------
dfile_e_nfor:	libmio_alertthis
		.db	0x4f,"Dataflash not formatted",0,0
		ret				;abort

;------------------------------------------------------------------------------
;error:no dataflash found  
;------------------------------------------------------------------------------
dfile_e_ndf:;	libmio_thistext
;		.db	0,0,"EREG:",0
;		clr	ctrl
;		push	XH
;		push	XL
;		mov	XL,ereg
;		libmio_outhex
;		pop	XL
;		pop	XH
		libmio_alertthis
		.db	0x4f,"Dataflash error!",0
		ret				;end

;------------------------------------------------------------------------------
;error:cannot save  
;------------------------------------------------------------------------------
dfile_e_cns:	libmio_alertthis
		.db	0x4f,"Can not save on this",0
		ret				;end


;------------------------------------------------------------------------------
;error:cannot load  
;------------------------------------------------------------------------------
dfile_e_cnlb:	libmio_alertthis
		.db	0x4f,"No BASIC file",0,0
		ret				;end

;------------------------------------------------------------------------------
;error:cannot restore 
;------------------------------------------------------------------------------
dfile_e_cnlm:	libmio_alertthis
		.db	0x4f,"No BACKUP file",0
		ret				;end


;------------------------------------------------------------------------------
;ask:overwrite  
;------------------------------------------------------------------------------
dfile_over:	libmio_askthis
		.db	0xc0,"Overwrite file?",0,0
		ret

;------------------------------------------------------------------------------
;ask:delete  
;------------------------------------------------------------------------------
dfile_adel:	libmio_askthis
		.db	0x4f,"Delete file?",0
		ret


;------------------------------------------------------------------------------
;no space left  
;------------------------------------------------------------------------------
dfile_e_nsl:	libmio_alertthis
		.db	0x4f,"No space left",0,0
		ret				;end

;------------------------------------------------------------------------------
;list 16 files  
;tempreg4=file
;------------------------------------------------------------------------------
dfile_list:	push	tempreg2
		push	tempreg3
		push	tempreg4
		mov	XL,tempreg4		;copy pagestart
		andi	XL,0xf0			;table start
		sts	dflash_asel,XL		;store first number to display
		
dfile_list_01:
;set cursor
		lds	XL,dflash_asel		;file number
		andi	XL,0x0f			;only position in table
		subi	XL,0xfb			;+5 (Y-pos)
		mov	XH,XL
		ldi	XL,0x04			;X-pos
		libmio_gotoxy			;set cursor
		ldi	XL,0x06			;color scheme (yellow on black)
		libmio_color
		
;output file number
		lds	XL,dflash_asel		;file number
		clr	XH			;max 256 files
		ldi	ctrl,0x05		;set format
		libmio_outdez			;output file number
		libmio_outspace			;and a space
		
;get file type to tempreg1
		ldi	XL,0x05			;color scheme (cyan on black)
		libmio_color
		lds	XL,dflash_asel		;file number
		sts	bas_partab,XL
		libdfl_gettype			;get file type
		rcall	dfile_pft		;print file type
		cpi	tempreg1,0xff		;empty
		breq	dfile_list_19		;yes
;		rjmp	dfile_list_17		;debug
		
;read first page
		lds	XL,dflash_asel		;position
		sts	bas_partab,XL		;set file number
		ldi	tempreg1,0x00
		sts	bas_partab+2,tempreg1
		ldi	tempreg1,0x02
		sts	bas_partab+4,tempreg1
		clr	ereg
		libdfl_read			;read this page
		cpi	ereg,0x00		;OK?
		brne	dfile_list_17		;no -> empty
		ldi	YL,LOW(bas_array+512)	;no copy
		ldi	YH,HIGH(bas_array+512)		
		
;separating space
		libmio_outspace	

;output file name
		ldi	tempreg2,0x0c		;name length
dfile_list_14:	push	tempreg2
		ld	tempreg1,Y+		;get char
		cpi	tempreg1,0x80		;valid?
		brcs	dfile_list_15		;branch if yes
		ldi	tempreg1,'.'		;replace
dfile_list_15:	cpi	tempreg1,0x20		;valid?
		brcc	dfile_list_16		;branch if yes
		ldi	tempreg1,' '		;replace
dfile_list_16:	libmio_outchar
		pop	tempreg2
		dec	tempreg2
		brne	dfile_list_14		;loop

dfile_list_17:	lds	XL,dflash_asel		;file number
		inc	XL			;+1
		sts	dflash_asel,XL		;store back
		andi	XL,0x0f			;only number in table
		breq	dfile_list_18
		rjmp	dfile_list_01
dfile_list_18:	pop	tempreg4
		pop	tempreg3
		pop	tempreg2
		ret

dfile_list_19:	ldi	tempreg2,0x0d		;name length +1
dfile_list_20:	libmio_outspace			;write space char
		dec	tempreg2		;loop counter
		brne	dfile_list_20		;loop
		rjmp	dfile_list_17		;ok, done


;------------------------------------------------------------------------------
;invert line tempreg4
;------------------------------------------------------------------------------
dfile_inv:	push	tempreg1
		push	tempreg2
		ldi	YL,LOW(libmio_vram+690+150+4)
		ldi	YH,HIGH(libmio_vram+690+150+4)
		mov	tempreg1,tempreg4	;copy line number
		andi	tempreg1,0x0f
		ldi	tempreg2,30		;chars per line
		mul	tempreg1,tempreg2
		add	YL,r0			;set offset
		adc	YH,r1
		ldi	tempreg2,0xf2		;blue on white
		ldi	tempreg1,0x17		;23 chars
dfile_inv_1:	st	Y+,tempreg2
		dec	tempreg1		;loop counter
		brne	dfile_inv_1		;loop		
		pop	tempreg2
		pop	tempreg1
		ret

;------------------------------------------------------------------------------
;re-invert line tempreg4
;------------------------------------------------------------------------------
dfile_reinv:	push	tempreg1
		push	tempreg2
		ldi	YL,LOW(libmio_vram+690+150+4)
		ldi	YH,HIGH(libmio_vram+690+150+4)
		mov	tempreg1,tempreg4	;copy line number
		andi	tempreg1,0x0f
		ldi	tempreg2,30		;chars per line
		mul	tempreg1,tempreg2
		add	YL,r0			;set offset
		adc	YH,r1
		ldi	tempreg2,0x0c		;yellow on black
		ldi	tempreg1,0x4		;4 chars
dfile_reinv_1:	st	Y+,tempreg2
		dec	tempreg1		;loop counter
		brne	dfile_reinv_1		;loop
		ldi	tempreg2,0x0a		;cyan on black
		ldi	tempreg1,0x13		;19 chars
dfile_reinv_2:	st	Y+,tempreg2
		dec	tempreg1		;loop counter
		brne	dfile_reinv_2		;loop
		pop	tempreg2
		pop	tempreg1
		ret


;------------------------------------------------------------------------------
;wait for key release
;------------------------------------------------------------------------------
dfile_wnk:	lds	XL,libmio_keycode
		cpi	XL,0
		brne	dfile_wnk		;wait for key release
		ret


;------------------------------------------------------------------------------
;save basic
;------------------------------------------------------------------------------
dfile_bsave:	sts	bas_partab,tempreg4	;file number
	    	ldi	tempreg1,0x0c		;12 pages
		sts	bas_partab+2,tempreg1	;set
		ldi	tempreg1,0x10		;file type
		sts	bas_partab+4,tempreg1	;set
		libdfl_create			;create new file
		cpi	ereg,0x00
		breq	dfile_bover
		rjmp	dfile_e_ndf		;dataflash error

		
;------------------------------------------------------------------------------
;overwrite basic
;------------------------------------------------------------------------------
dfile_bover:	sts	bas_partab,tempreg4	;file number
		lds	ctrl,libmio_lastmenu	;program number
		ldi	ZL,LOW(bas_programs*2)
		ldi	ZH,HIGH(bas_programs*2)
		andi	ctrl,0x07		;limit programs
		swap	ctrl			;fileno*16
		ldi	tempreg1,0xc0		;*192
		mul	ctrl,tempreg1
		add	ZL,r0			;file offset
		adc	ZH,r1
		ldi	tempreg1,0x00		;first data page
dfile_bover_1:	push	tempreg1
		ldi	r16,0x00		;bytes to copy
		ldi	YL,LOW(bas_array+512)	;buffer
		ldi	YH,HIGH(bas_array+512)
dfile_bover_2:	lpm	r17,Z+			;get flash data
		st	Y+,r17			;write to buffer			
		dec	r16
		brne	dfile_bover_2
		sts	bas_partab+2,tempreg1	;page number
		ldi	tempreg1,0x02		;array pos
		sts	bas_partab+4,tempreg1	;set
		libdfl_write			;write page
		pop	tempreg1
		inc	tempreg1
		cpi	tempreg1,0x0c		;all done
		brne	dfile_bover_1
		ret

;------------------------------------------------------------------------------
;load basic
;------------------------------------------------------------------------------
dfile_bload:	lds	ctrl,libmio_lastmenu
		andi	ctrl,0x07		;8 programs
		ldi	ZL,LOW(bas_programs*2)
		ldi	ZH,HIGH(bas_programs*2)
		swap	ctrl			;fileno*16
		ldi	tempreg1,0xc0		;*192
		mul	ctrl,tempreg1
		add	ZL,r0			;file offset
		adc	ZH,r1
		ldi	tempreg1,0x00		;first data page
dfile_bload1:	push	tempreg1
		sts	bas_partab+2,tempreg1	;page number
		ldi	tempreg1,0x02		;array pos
		sts	bas_partab+4,tempreg1	;set
		sts	bas_partab,tempreg4	;file number
		libdfl_read
		ldi	YL,LOW(bas_array+512)	;buffer
		ldi	YH,HIGH(bas_array+512)	
		call	mem_writepage		;write to flash
		adiw	ZL,2			;next flash page
		pop	tempreg1
		inc	tempreg1		;page counter
		cpi	tempreg1,0x0c		;last?
		brne	dfile_bload1		;no
		sei
		ret	

		
;------------------------------------------------------------------------------
;print file type (tempreg1)
;------------------------------------------------------------------------------
dfile_pft:	cpi	tempreg1,0x10		;BASIC
		brne	dfile_pft_01		;no
		libmio_thistext
		.db	255,"BAS:",0
		ldi	tempreg1,0x10
		ret

dfile_pft_01:	cpi	tempreg1,0x12		;BACKUP
		brne	dfile_pft_02		;no
		libmio_thistext
		.db	255,"BUP:",0
		ldi	tempreg1,0x12
		ret

dfile_pft_02:	cpi	tempreg1,0x14		;USER
		brne	dfile_pft_99		;no
		libmio_thistext
		.db	255,"USR:",0
		ldi	tempreg1,0x14
		ret

dfile_pft_99:	libmio_thistext			;NO FILE
		.db	255,"----",0
		ldi	tempreg1,0xff		;empty
		ret	
		
;------------------------------------------------------------------------------
;create backup
;------------------------------------------------------------------------------
dfile_msave:	sts	bas_partab,tempreg4	;file number
	    	ldi	tempreg1,0x60		;96 pages
		sts	bas_partab+2,tempreg1	;set
		ldi	tempreg1,0x12		;file type
		sts	bas_partab+4,tempreg1	;set
		libdfl_create			;create new file
		cpi	ereg,0x00
		breq	dfile_mover
		rjmp	dfile_e_ndf		;dataflash error


;------------------------------------------------------------------------------
;overwrite backup
;------------------------------------------------------------------------------
dfile_mover:	sts	bas_partab,tempreg4	;file number
		clr	tempreg1		;first page
		ldi	ZL,LOW(bas_programs*2)
		ldi	ZH,HIGH(bas_programs*2)
dfile_mover1:	push	tempreg1
		ldi	YL,LOW(bas_array+512)	;buffer
		ldi	YH,HIGH(bas_array+512)
		clr	r0			;256 bytes
dfile_mover2:	lpm	r1,Z+			;copy from flash to ram
		st	Y+,r1		
		dec	r0
		brne	dfile_mover2		;loop
		sts	bas_partab+2,tempreg1	;page number
		ldi	tempreg1,0x02		;array pos
		sts	bas_partab+4,tempreg1	;set
		libdfl_write			;write page 0
		pop	tempreg1
		inc	tempreg1		;page+1
		cpi	tempreg1,0x60
		brne	dfile_mover1
		ret

;------------------------------------------------------------------------------
;restore
;------------------------------------------------------------------------------
dfile_mload:	ldi	tempreg1,0x00		;first data page
		ldi	ZL,LOW(bas_programs*2)	;start address
		ldi	ZH,HIGH(bas_programs*2)
		
dfile_mload1:	push	tempreg1
		sts	bas_partab+2,tempreg1	;page number
		ldi	tempreg1,0x02		;array pos
		sts	bas_partab+4,tempreg1	;set
		sts	bas_partab,tempreg4	;file number
		libdfl_read
		ldi	YL,LOW(bas_array+512)	;buffer
		ldi	YH,HIGH(bas_array+512)
		call	mem_writepage
		adiw	ZL,2			;correct pointer
		pop	tempreg1
		inc	tempreg1
		cpi	tempreg1,0x60
		brne	dfile_mload1		
		sei
		ret	

;------------------------------------------------------------------------------
;write-alertbox
;------------------------------------------------------------------------------
dfile_wal:	push	tempreg1		;save registers
		push	ZH
		push	ZL
		push	YH
		push	YL
		push	XH
		push	XL
		lds	tempreg1,libmio_color	;old color
		sts	bas_partab+9,tempreg1	;save
		ldi	tempreg1,0x4c		;yellow on red
		sts	libmio_color,tempreg1	;set new color
		ldi	YL,6
		ldi	YH,10
		ldi	ZL,23
		ldi	ZH,12
		libmio_wbox			;draw window
		libmio_thistext
		.db 	11,7,"Writing data...",0
		lds	tempreg1,bas_partab+9
		sts	libmio_color,tempreg1	;restore old color
		pop	XL			;restore registers
		pop	XH
		pop	YL
		pop	YH
		pop	ZL
		pop	ZH
		pop	tempreg1
		ret
		
		
		
					